; ISP_PROC_J_PCB2_FCNYRIM.ASM
; --------------------------------------------------------------------
;
; 01.08.2012
;
; Firmware des ISP-Flashers fr:
;
; Version 0.3 J / Platinenlayout 2
; (ISP-Leitungen sind lediglich ber 68 Ohm Widerstnde bedmpft)
;
; --------------------------------------------------------------------
; AT89S51
; AT89S52
; AT89S2051
; AT89S4051
; AT89S8253
;
; bertragungsgeschwindigkeit whlbar: 28800 Bd / 115200 Bd
;
; PC-Hostprogramm: ISP-Prog v 0.3
;
; Firmware MCU: AT89C2051
;
; Firmwareversion fr:
; ISP Leitungen OHNE ULN 2004 und OHNE Invertertransistor fr
; die Misoleitung
;
; !!!! Dieses Programm ist NICHT im AT89SXX
; abgelegt, es befindet sich in dem Controller,
; der die Target-MCU flasht !!!!
;
; Bugbereinigung dieses Releases:
;                                AT89S8253 funktioniert jetzt fehlerfrei
;
;
; Version fr den komplett abgespeckten FLASHER, KEIN ULN2004, kein Invertertransistor
; MOSI,MISO,SCK,RES Belegung fr die ALTEN IDC-10 Stecker
;
; 16.08.2012

; --------------------------------------------------------------------

; ---------------------- Deklarationen ---------------------------

; Alle Anschlsse werden invertiert an den zu flashenden Controller
; angeschaltet !


; ---------------------------------------------------------------
;         ACHTUNG: genderte Anschlsse am P1
; ---------------------------------------------------------------
miso           equ    090h
mosi           equ    093h
sck            equ    091h
res            equ    092h
LEDgn          equ    0b7h             ; P3.7
LEDrt          equ    091h             ; P3.4
isp_port       equ    090h             ; P1

clocks         equ    15               ; Grundwartezyklen beim Flashen eines Bytes


; -------------- Variable / Byte-Speicherbelegung ---------------

stringvar      equ    40h             ; Pufferspeicher fr einen String
stringptr      equ    51h             ; Zeiger auf die Stringvariable

startadrlo     equ    60h             ; Adresse ab der das zu flashende
startadrhi     equ    61h             ; Programm gespeichert werden soll
proglenlo      equ    62h             ; Lo-Byte der Programmlaenge
proglenhi      equ    63h             ; Hi-Byte der Programmlaenge
byte2burn      equ    64h             ; zu brennendes Byte

progmode       equ    65h             ; die verschiedenen AT89S - Typen haben unterschiedliche Timings
                                      ; in Bezug auf das Lesen (MISO), auf die Dauer bis zur internen
                                      ; bernahme eines gesendeten Bytes und eine unterschiedliche
                                      ; Initialisierung bezglich des Pegels von SCK
                                      ; Progmode= 0 fr AT89S52 und AT89S53
                                      ; Progmode= 1 fr AT89S8253 und AT89SX051
misobyte       equ    66h             ; seriell auf MISO eingelesener Wert

diagstarthi    equ    67h             ; Variable der Start- und Endadressen, die im
diagstartlo    equ    68h             ; Diagnosemodus verwendet werden
diagendhi      equ    69h
diagendlo      equ    6ah

mcuident       equ    6bh             ; nimmt Kennung der MCU auf: 69 fr 89S51 / 52
                                      ;                            23 fr AT89S2051
                                      ;                            43 fr AT89S4051
                                      ;                            73 fr AT89S8253

pagedatafehler equ    6bh
pagedatapuffer equ    80h             ; Zwischenspeicher, in den die Daten beim Brennen im Pagemodus
                                      ; "zwischengelagert" werden

; -------------- Variable / Bit-Speicherbelegung ----------------

fehlerbit      equ    00h             ; Fehler beim Brennen
inProg         equ    01h             ; Anzeigeflag, ob im Programming-Mode

cseg at 0h

ajmp main


cseg at 0bh

  reti

Delay1:
  ; Verzoegerungschleife
  ; (12 MHz: R7 * 0,156 mS)
  ; Uebergabe:
  ;            R7 = Verzoegerungsfaktor
  push 06
  push 07
delo0:
  mov r6,#70
delo1:
  djnz r6,delo1
  djnz r7,delo0
  pop 07
  pop 06
  ret

delay10:
  ; Verzoegerungsschleife
  ; (12 MHz: R6 * 15 ms)
  push 06
  push 07
  mov r7,#100
delo10_0:
  acall delay1
  djnz r6,delo10_0
  pop 07
  pop 06
  ret

ClkDelay:
  ; Verzoegerungschleife
  ; Verzoegerungswert ca. R7 * 500 Taktzyklen
  ; (12 MHz: R7 * 0,5 mS)
  ; Uebergabe:
  ;            R7 = Verzoegerungsfaktor
  push 06
  push 07
cdelo0:
  mov r6,#2
cdelo1:
  djnz r6,cdelo1
  djnz r7,cdelo0
  pop 07
  pop 06
  ret

MosiOut:
  ; gibt Wert seriell auf dem MOSI aus
  ; Uebergabe:
  ;            A = auszugebender Wert
  push acc
  push 0
  push 6
  clr c
  mov r0,#8
mosiloop:
  rlc a
  mov mosi,c
  nop
  nop
  nop
  setb sck
  nop
  nop
  nop
  clr sck
  djnz r0,mosiloop
  pop 6
  pop 0
  pop acc
  ret

MisoIn_Mode1:
  ; liest den Wert auf Miso ein
  ; Uebergabe: keine
  ; Rueckgabe: A = gelesener Wert
  setb miso
  clr mosi
  clr sck
  push 6
  push 0
  nop
  nop
  nop
  mov r0,#8
misomode1loop:
  setb miso
  setb sck
  mov r7,#1
  acall clkdelay
  mov c,miso
  rlc a                        ; gelesenes Bit einlesen
  mov r7,#1
  acall clkdelay
  setb miso
  clr sck
  djnz r0,misomode1loop
  setb miso
  pop 0
  pop 6
  ret

MisoIn:
  ; liest den Wert auf Miso ein
  ; Uebergabe: keine
  ; Rueckgabe: A = gelesener Wert
  mov a,progmode
  cjne a,#1,normalmisoin
  jnz misoin_mode1
normalmisoin:
  setb miso
  clr mosi
  push 6
  push 0
  nop
  nop
  nop
  mov r0,#8
misoloop:
  setb miso
  setb sck
  nop
  nop
  nop
  mov c,miso
  rlc a                        ; gelesenes Bit einlesen
  nop
  nop
  nop
  setb miso
  clr sck
  nop
  nop
  nop
  djnz r0,misoloop
  clr miso
  pop 0
  pop 6
  ret

writebyte:
  ; Schreibmodus fr AT89S
  ; Uebergabe:   R0 = Lo-Byte Adresse
  ;              R1 = Hi-Byte Adresse
  ;              A  = zu schreibendes Byte
  push acc
  mov a,#40h
  acall mosiout
  mov a,r1
  acall mosiout
  mov a,r0
  acall mosiout
  pop acc
  acall mosiout
  mov r7,#clocks            ; Grundverzgerungswert fr AT89S51 / 52
  acall clkdelay
  mov r7,progmode
  cjne r7,#00,wrbye_notmode0
  ret
wrbye_notmode0:
  mov r7,#50                ; Verzoegerungswert fr AT89S8253
  acall delay1
  ret

readbyte:
  ; Lesemodus beim AT89SXX
  ; Uebergabe:   R0 = Lo-Byte Adresse
  ;              R1 = Hi-Byte Adresse
  ; Rueckgabe:   A  = gelesenes Byte
  mov a,#20h
  acall mosiout
  mov a,r1
  acall mosiout
  mov a,r0
  acall mosiout
  acall misoin
  ret

clear_at89S52:
  ; loescht den gesamten Codespeicher des AT89SXX
  ; Uebergabe:         keine
  ; Rueckgabe:         keine
  mov a,#0ach
  acall mosiout
  mov a,#80h
  acall mosiout
  mov a,#0
  acall mosiout
  mov a,#0
  acall mosiout
  mov r6,#10
  acall delay10        ; warten bis der Chip garantiert gelscht ist
  ret

reset_isp_pins:
  clr res
  clr sck
  clr mosi
  setb miso
  ret

InitStart:
  ; initialisiert MCU fr Ausgaben ber MOSI
  acall reset_isp_pins
  mov a,progmode
  anl a,#1
  setb sck
  jnz initprogramming_not52
  clr sck             ; (clr sck) fr AT89S8253.... (setb sck) fr AT89S52
initprogramming_not52:
  mov r7,#10
  acall delay1
  setb res
  acall delay1
  clr res
  acall delay1
  setb res
  mov r7,#10
  acall delay1
  ret

prgEnable_sequenz:
  acall reset_isp_pins
  mov a,#0ach
  acall mosiout
  mov a,#053h
  acall mosiout
  mov a,#0h
  acall mosiout
  acall misoin
  ret

InitProgramming:
  ; initialisiert den 89SXX fuer den Programmiermode
  ; Hardware (Invertierung der Hardware beachten) SCK = 0; RES = 1;
  ; Wartezeit einhalten; Programming Enable senden
  ; Rueckgabe:    A = Kennung des Controllers
  acall initstart
  mov a,#0ach          ; ACh = Programming Enable Command 1.Byte
  acall mosiout
  mov a,#053h          ; 53h = Programming Enable Command 2.Byte
  acall mosiout
  mov a,#0h
  acall mosiout        ; 3. Byte als Leerbyte senden
  acall misoin         ; eingelesener Wert bei einem AT89S52/AT89S51 = "69h" ansonsten "00h"
  mov misobyte,a
  cjne a,#69h,init_no_89s52
  ret                  ; es war ein AT89S51 / 52, Inititalisierung beendet
init_no_89s52:
  mov a,progmode
  jnz initprog_end     ; Progmode war bereits 1, Initialisierung beendet
  mov progmode,#1
  sjmp initprogramming
initprog_end:
  mov a,misobyte
  ret

GetAtmelSig:
  ; stellt fest, um welchen MCU es sich handelt.
  ; Erkennt KEINE 89S51 / 52 (die werden bei der Initialisierung erkannt)
  ; Hardware (Invertierung der Hardware beachten) SCK = 0; RES = 1;
  ; Wartezeit einhalten; Programming Enable senden
  ; Rueckgabe:    A = Kennung des Controllers

  clr inprog
  mov progmode,#0
  mov r7,#10
  acall delay1
  acall initprogramming
  mov mcuident,a            ; MCU-Typkennung speichern
  setb inprog
  cjne a,#69h,Sig_No52      ; es war ein AT89S51 oder AT89S52
  ret
Sig_no52:
  mov r7,#10
  acall delay1
  mov a,#28h
  acall mosiout
  mov a,#00h
  acall mosiout
  mov a,#031h               ; 28.00.31h = Signatur lesen an Adresse 31h
  acall mosiout
  acall misoin              ; eingelesener Wert
  cjne a,#73h,Sig_No8253    ; ist Wert <> 73 war es kein AT89S8253
  mov mcuident,a
  ret
sig_no8253:
  mov r7,#10
  acall delay1
  mov a,#28h
  acall mosiout
  mov a,#00h
  acall mosiout
  mov a,#01h
  acall mosiout
  acall misoin              ; liefert 23h fr einen AT89S2051, 43h fr einen AT89S4051
  mov mcuident,a
  ret

burn_prog_page:
  ; ------------------------------- WICHTIG --------------------------------------
  ; !!!!! kein eigenstndiges Unterprogramm, wird von <burn_prog> angesprungen wenn im Pagemodus geflasht wird !!!
  ; ------------------------------------------------------------------------------
  ; liest von der RS-232 das zu brennende Programm ab der Adresse
  ; STARTADRHI:STARTADRLO sind in DPH und DPL von <burn_prog> schon gesetzt
  ; PROGLENHI:PROGLENLO sind in R4 und R3 von <burn_prog> schon gesetzt

  clr fehlerbit

burn_prog1_codesequenz:
  mov r7,#50                   ; Verzoegerungswert fr AT89S8253 und AT89Sx051
  acall delay1
  mov a,#50h
  acall mosiout                ; Code Write Code Page
  mov a,dph
  acall mosiout                ; High-Adress der Code Page
  mov a,mcuident
  cjne a,#73h,burn_prog1_no8253
                               ; 64 Byte Pagewritemodus des AT89S8253
  mov a,dpl
  anl a,#0c0h                  ; Lo-Adress der Code Page, Datenadresse 0..31 gelscht
  acall mosiout
  mov r5,#64                   ; 64 Datenbytes im Pagewritemodus
  mov r0,#pagedatapuffer
  sjmp burn_prog1_p

burn_prog1_no8253:
                               ; 32 Byte Pagewritemodus des AT89Sx051
  mov a,dpl
  anl a,#0e0h                  ; Lo-Adress der Code Page, Datenadresse 0..31 gelscht
  acall mosiout
  mov r5,#32                   ; 32 Datenbytes im Pagewritemodus
  mov r0,#pagedatapuffer

burn_prog1_p:
  mov a,r5
  jz burn_prog1_codesequenz
  acall getrs232hex            ; Zeichen von Schnittstelle lesen

  mov @r0,a                    ; gelesene Daten zwischenspeichern
  inc r0
  acall mosiout                ; und auf ISP senden
  mov r7,#clocks               ; Grundverzgerungswert fr AT89S51 / 52
  acall clkdelay
  mov a,#79                    ; sende Ascii "O" bei fehlerfrei
  acall sendchar
burnweiter_p:
  inc dptr                     ; zu flashende Code-Adresse
  dec r5                       ; Bytes der Codepage herunter zhlen
  dec r3                       ; Programmlaengenzaehler Lo-Byte
  cjne r3,#0ffh,burn_prog1_p
  dec r4                       ; Programmlaengenzaehler Hi-Byte
  cjne r4,#0ffh,burn_prog1_p   ; 16-Bit Programmlaengenzaehler - 1
burn_prog_end_p:
  mov a,r5
  jz burn_prog_exit_p
  mov a,#0ffh
  acall mosiout
  mov r7,#clocks               ; Grundverzgerungswert fr AT89S51 / 52
  acall clkdelay
  dec r5
  sjmp burn_prog_end_p
burn_prog_exit_p:
  mov r7,#50                   ; Verzoegerungswert fr AT89S8253 und AT89Sx051
  acall delay1
  mov a,#0ach                  ; zur Sicherheit die User-Fuses so schreiben,
  acall mosiout
  mov a,#1ah                   ; dass ISP-enabled ist (0= enable)
  acall mosiout
  mov a,#0
  acall mosiout
  mov a,#0
  acall mosiout
  mov r7,#50                   ; Verzoegerungswert fr AT89S8253 und AT89Sx051
  acall delay1
  ret

burn_prog:
  ; liest von der RS-232 das zu brennende Programm ab der Adresse
  ; STARTADRHI:STARTADRLO mit der Programmlaenge PROGLENHI:PROGLENLO
  ; Uebergabe: keine
  ; Rueckgabe: Fehlerbit = 0 wenn Brennvorgang erfolgreich
  ;            Fehlerbit = 1 wenn Fehler aufgetreten

  clr fehlerbit
  mov dph,startadrhi
  mov dpl,startadrlo
  mov r4,proglenhi
  mov r3,proglenlo
  jb inprog,no_initprogramming
  acall initprogramming
  setb inprog
no_initprogramming:

burn_prog1:
  mov a,progmode
  jz no_burn_prog_page
  ajmp burn_prog_page          ; Writemodus Page fr AT89Sx051 und AT89S8253
no_burn_prog_page:
  acall getrs232hex
  mov byte2burn,a
  mov r5,#3
burn_02:
  mov r1,dph
  mov r0,dpl
  mov a,byte2burn
  acall writebyte
  acall readbyte
  cjne a,byte2burn,burnfehler
  mov a,#79                    ; sende Ascii "O" bei fehlerfrei
  acall sendchar
  mov r5,#3                    ; max. 3 Brennversuche
  sjmp burnweiter
burnfehler:
  djnz r5,burn_02
  mov a,#69
  acall sendchar               ; sende Ascii "E" bei Fehler
  mov r5,#3
burnweiter:
  inc dptr                     ; zu flashende Code-Adresse
  dec r3                       ; Programmlaengenzaehler Lo-Byte
  cjne r3,#0ffh,burn_prog1
  dec r4                       ; Programmlaengenzaehler Hi-Byte
  cjne r4,#0ffh,burn_prog1     ; 16-Bit Programmlaengenzaehler - 1
burn_prog_end:
  ret

read_prog:
  ; liest den Codespeicher der MCU ab der Adresse
  ; STARTADRHI:STARTADRLO mit der Programmlaenge PROGLENHI:PROGLENLO
  ; und sendet diese als HEX-Bytes auf der RS-232
  ; Uebergabe: keine

  mov dph,startadrhi
  mov dpl,startadrlo
  mov r4,proglenhi
  mov r3,proglenlo
  jb inprog,no_initprogramming_read
  acall initprogramming
  setb inprog
no_initprogramming_read:

read_prog1:
  mov r1,dph
  mov r0,dpl
  acall readbyte
  acall writehex2rs232

  inc dptr                     ; zu flashende Code-Adresse
  dec r3                       ; Programmlaengenzaehler Lo-Byte
  cjne r3,#0ffh,read_prog1
  dec r4                       ; Programmlaengenzaehler Hi-Byte
  cjne r4,#0ffh,read_prog1     ; 16-Bit Programmlaengenzaehler - 1
  ret

read_code:
  ; liest den Codespeicher der MCU im Diagnosemodus und fordert den
  ; Anwender zuvor auf, die Start und die Endadresse des zu lesenden
  ; Speicherbereiches anzugeben. Codespeicher wird ber die RS-232
  ; angezeigt
  ; bergabe: keine

  jb inprog,no_initprogramming_readcode
  acall initprogramming
  setb inprog
no_initprogramming_readcode:
  mov dptr,#readmeld
  acall sendromstring
  acall getrs232hex_echo
  mov diagstarthi,a
  acall getrs232hex_echo
  mov diagstartlo,a
  acall makelinefeed
  mov dptr,#readendadressmeld
  acall sendromstring
  acall getrs232hex_echo
  mov diagendhi,a
  acall getrs232hex_echo
  inc a
  jnz no_readcode_hiadd
  inc diagendhi
no_readcode_hiadd:
  mov diagendlo,a
  acall makelinefeed
  push dpl
  push dph
  mov dph,diagstarthi
  mov dpl,diagstartlo
read_code_loop:
  mov a,dph
  acall writehex2rs232                 ; hherwertiges Byte der Adresse ausgeben
  mov a,dpl
  acall writehex2rs232                 ; dto. niederwertiges Byte
  mov a,#" "
  acall sendchar
  mov stringptr,#stringvar             ; Zeiger auf den String im int. RAM
  mov r2,#17
read_frame_loop:
  djnz r2,readframe_anz                ; ist ein kompletter 16er "Frame" angezeigt?
  mov a,#" "
  acall sendchar
  mov a,#" "
  mov a,#":"
  acall sendchar
  mov a,#" "
  acall sendchar
  mov a,#" "
  acall sendchar
  mov r0,stringptr
  mov @r0,#0
  mov r0,#stringvar
  acall sendramstring
  acall makelinefeed
  ajmp read_code_loop                  ; dann einen neuen Frame beginnen
readframe_anz:
  mov r0,dpl
  mov r1,dph
  acall readbyte                       ; Byte aus Flash lesen, das in R1:R0 adressiert ist

  push acc                             ; ab hier wird ein String aus den ausgelesenen Bytes erzeugt
  mov r0,stringptr
  cjne a,#31,read_testascii
read_noascii:
  mov a,#"."
  sjmp read_endascii
read_testascii:
  jc read_noascii
read_endascii:
  mov @r0,a
  inc stringptr

  pop acc
  acall writehex2rs232                 ; und auf RS232 ausgeben

  inc dptr
  mov a,dpl
  cjne a,diagendlo,read_frame_loop
  mov a,dph
  cjne a,diagendhi,read_frame_loop

  mov a,#" "
  acall sendchar
  mov a,#" "
  mov a,#":"
  acall sendchar
  mov a,#" "
  acall sendchar
  mov a,#" "
  acall sendchar
  mov r0,stringptr
  mov @r0,#0
  mov r0,#stringvar
  acall sendramstring
  acall makelinefeed
  pop dph
  pop dpl
  ret


; ----------------------------------------------
;  Diagnosemodus
;  Programmroutine zur Bedienung des Flasher's
;  ber ein Terminalprogramm
; ----------------------------------------------
diagmode:
  clr inprog
  mov progmode,#0
  acall initprogramming
  setb inprog
  mov dptr,#diagnosemeld
  acall sendromstring
diagmenu:
  acall readchar
  cjne a,#"n",diag_noinit
  ; -----------------------------------------------
  ; Diagnosemenu "n" = Controller initialisieren
  ;                    MCU identifizieren
  ; -----------------------------------------------
  mov dptr,#diaginimeld
  acall sendromstring
  acall getatmelsig
  cjne a,#69h,diag_no52
  mov dptr,#typ0string
  acall sendromstring
  sjmp diagmenu
diag_no52:
  cjne a,#73h,diag_no8253
  mov dptr,#typ1string
  acall sendromstring
  sjmp diagmenu
diag_no8253:
  cjne a,#23h,diag_no2051
  mov dptr,#typ2string
  acall sendromstring
  sjmp diagmenu
diag_no2051:
  cjne a,#43h,diag_noMcufound
  mov dptr,#typ3string
  acall sendromstring
  sjmp diagmenu
diag_nomcufound:
  mov dptr,#typnotfoundstring
  acall sendromstring
  sjmp diagmenu

diag_noinit:
  cjne a,#"o",diag_nomosi
  ; -----------------------------------------------
  ; Diagnosemenu "o" = MOSI-Wert ausgeben
  ; -----------------------------------------------
  mov dptr,#mosioutmeld
  acall sendromstring
  acall getrs232hex_echo
  acall makelinefeed
  acall mosiout
  sjmp diagmenu

diag_nomosi:
  cjne a,#"i",diag_nomiso
  ; -----------------------------------------------
  ; Diagnosemenu "i" = MISO-Wert einlesen
  ; -----------------------------------------------
  mov dptr,#misoinmeld
  acall sendromstring
  acall misoin
  acall writehex2rs232
  acall makelinefeed
  sjmp diagmenu

diag_nomiso:
  cjne a,#"p",diag_nopindefault
  ; -----------------------------------------------
  ; Diagnosemenu "p" = Pin auf Defaultwerte
  ; -----------------------------------------------
  acall initstart
  sjmp diagmenu

diag_nopindefault:
  cjne a,#"r",diag_noread
  ; -----------------------------------------------
  ; Diagnosemenu "r" = liest den Codespeicher
  ; -----------------------------------------------
  acall read_code
  sjmp diagmenu2

diag_noread:
  cjne a,#"e",diagmenu2
  sjmp diag_exit
diagmenu2:
  ajmp diagmenu
diag_exit:
  mov dptr,#diagendemeld
  acall sendromstring
  ret


; ----------------------------------------------
;  Hauptprogramm
; ----------------------------------------------

main:
  mov sp,#70h
  mov isp_port,#0ffh
  clr res
  mov progmode,#0              ; Progmode=0 : AT89S51 / AT89S52
                               ;         =1 : AT89S8253
  acall inittimer
  acall reset_isp_pins
  clr inprog
  mov dptr,#brennermeld
  acall sendromstring          ; Startmeldung beim Einschalten anzeigen
  mov proglenhi,#0
  mov proglenlo,#4
  mov startadrhi,#0
  mov startadrlo,#0

brenner_menu:
  setb ledgn                    ; grne LED an
  clr ledrt
  acall readchar
  cjne a,#"1",menu2             ; berspringen wenn das gelesene Zeichen NICHT "1" war
  ; -----------------------------------------------
  ; Menupunkt "1" = loeschen
  ; -----------------------------------------------
  mov progmode,#0
  acall initprogramming
  acall clear_at89s52
  setb inprog
  sjmp brenner_menu

menu2:
  cjne a,#"2",menu3             ; berspringen wenn das gelesene Zeichen NICHT "2" war
  ; -----------------------------------------------
  ; Menupunkt 2 = Startadresse ueber RS-232 holen
  ; -----------------------------------------------
  acall getrs232hex
  mov startadrhi,a
  acall writehex2rs232
  acall getrs232hex
  mov startadrlo,a
  acall writehex2rs232
  sjmp brenner_menu

menu3:
  cjne a,#"3",menu4             ; berspringen wenn das gelesene Zeichen NICHT "3" war
  ; -----------------------------------------------
  ; Menupunkt 3 = Anzahl zu flashender Bytes
  ;               ueber RS-232 holen
  ; -----------------------------------------------
  acall getrs232hex
  mov proglenhi,a
  acall writehex2rs232
  acall getrs232hex
  mov proglenlo,a
  acall writehex2rs232
  sjmp brenner_menu

menu4:
  cjne a,#"4",menu5             ; berspringen wenn das gelesene Zeichen NICHT "4" war
  ; -----------------------------------------------
  ; Menupunkt 4 = Reset Chip
  ; -----------------------------------------------
manuell_reset:
  mov isp_port,#0ffh
  setb res
  mov r6,#5
  acall delay10
  clr res
  clr inprog
  sjmp brenner_menu

menu5:
  cjne a,#"5",menu6
  ; -----------------------------------------------
  ; Menupunkt 5 = Brennermeldung ausgeben
  ; -----------------------------------------------
  mov dptr,#brennermeld
  acall sendromstring
  sjmp brenner_menu

menu6:
  cjne a,#"6",menu7
  ; -----------------------------------------------
  ; Menupunkt 6 = Daten brennen
  ; -----------------------------------------------
  clr ledgn
  setb ledrt
  acall burn_prog
  sjmp brenner_menu

menu7:
  cjne a,#"7",menu8
  ; -----------------------------------------------
  ; Menupunkt 7 = Codespeicher lesen
  ; -----------------------------------------------
  acall read_prog
  ajmp brenner_menu

menu8:
  cjne a,#"8",menu9
  ; -----------------------------------------------
  ; Menupunkt 8 = Chip identifizieren
  ; -----------------------------------------------
  acall GetAtmelSig
  acall writehex2rs232
  ajmp brenner_menu

menu9:
  cjne a,#"9",menu_o
  ; -----------------------------------------------
  ; Menupunkt 9 = Diagnosemodus aufrufen
  ; -----------------------------------------------
  acall diagmode
  ajmp brenner_menu

menu_o:
  cjne a,#"o",menu_i
  ; -----------------------------------------------
  ; Menupunkt "o" = einzelnes Mosi-Byte senden
  ; -----------------------------------------------
  acall getrs232hex
  push acc
  acall writehex2rs232
  pop acc
  acall mosiout
  ajmp brenner_menu

menu_i:
  cjne a,#"i",menu_s
  ; -----------------------------------------------
  ; Menupunkt "i" = einzelnes Mosi-Byte senden
  ; -----------------------------------------------
  acall misoin
  acall writehex2rs232
  ajmp brenner_menu
  
menu_s:
  cjne a,#"s",menu_end
  ; -----------------------------------------------
  ; Menupunkt "s" = Startsequenz fr ISP aufrufen
  ; -----------------------------------------------
  acall initstart
  ajmp brenner_menu
  
menu_end:
  ajmp brenner_menu


brennermeld:
  db 13,10,"AT89Sxx ISP-Flash Programmer v0.3 / PCB-2"
  db 13,10,"unterstuetzte Controller:  AT89S51   - AT89S52"
  db 13,10,"                           AT89S2051 - AT89S4051"
  db 13,10,"Version 1.0                AT89S8253",13,10
  db 13,10,"Steuerkommandos"
  db 13,10,"1 - Clear \ 2 - Startadresse \ 3 - Programmlaenge"
  db 13,10,"4 - Reset \ 5 - Meldung      \ 6 - Flashen"
  db 13,10,"7 - Lesen \ 8 - MCU-Typ      \ 9 - Diagnose",13,10
  db 13,10,"O - mOsi  \ I - mIso         \ S - Startseq",13,10,0

diagnosemeld:
  db 13,10,"Diagnosemode"
  db 13,10,"Auswahltasten",13,10
  db 13,10,"-- m[o]si -- m[i]so -- i[n]it -- [r]ead -- [P]in default -- [e]xit --",13,10,0
diagendemeld:
  db 13,10,"--- Ende Diagnosemode ---",13,10,0
diaginimeld:
  db 13,10,"gefundene MCU: ",0
mosioutmeld:
  db "MOSI-Out[hex]: ",0
misoinmeld:
  db "MISO-In[hex]:  ",0
readmeld:
  db 13,10,"Codespeicher lesen",13,10
  db "Startadresse: ",0
readendadressmeld:
  db "Endadresse: ",0

Typ0String:
  db "AT89S51 / AT89S52",13,10,0
Typ1String:
  db "AT89S8253",13,10,0
Typ2String:
  db "AT89S2051",13,10,0
Typ3String:
  db "AT89S4051",13,10,0
TypNotFoundString:
  db "keine",13,10,0


; ----------------------------------------------
;  Grundfunktionen zur RS232
; ----------------------------------------------

SendROMString:
  ; sendet einen nullterminierten String an die RS232 Schnittstelle
  ;    DPTR => Adresse des Strings im ext. Programmspeicher
  clr a
  movc a,@a+dptr
  jz end_of_transmit
  mov sbuf,a
wait_transmit:
  jnb ti,wait_transmit  ; warten, bis Zeichen gesendet ist
  clr ti                ; gesendet Zeichen zurcknehmen
  inc dptr
  sjmp sendromstring
end_of_transmit:
  ret
  
SendRAMString:
  ; sendet einen nullterminierten String an die RS232 Schnittstelle
  ;    R0 => Adresse des Strings im int. RAM
  mov a,@r0
  jz end_of_ramtransmit
  mov sbuf,a
wait_ramtransmit:
  jnb ti,wait_ramtransmit  ; warten, bis Zeichen gesendet ist
  clr ti                   ; gesendet Zeichen zurcknehmen
  inc r0
  sjmp sendramstring
end_of_ramtransmit:
  ret


ReadChar:
  ; wartet, bis ein Zeichen auf der ser. Schnittstelle eintrifft.
  ; Rckgabe:
  ;   A => eingegangenes Zeichen
  jnb ri,readchar         ; warten, bis Zeichen eingegangen ist
  mov a,sbuf
  clr ri
  nop
  nop
  ret


SendChar:
  ; sendet Zeichen auf der RS232
  ;   A => zu sendendes Zeichen

  mov sbuf,a                   ; Zeichen an Terminal senden
waitsendch:
  jnb ti,waitsendch            ; und warten bis dieses gesendet ist.
  clr ti
  ret
  
MakeLineFeed:
  ; sendet CR und LF auf der RS232
  push acc
  mov a,#13
  acall sendchar
  mov a,#10
  acall sendchar
  pop acc
  ret

convhexchar:
  ; konvertiert ein Hexzeichen in ein grossgeschriebenes Hexzeichen
  ; bergabe:          A  = zu konvertierendes Zeichen
  ; Rckgabe:          A  = konvertiertes Zeichen
  ;                    R1 = Ziffernwert des Zeichens

  cjne a,#57,conv_testziffer
  sjmp numziffer               ; A war "9"
conv_testziffer:
  jc numziffer                 ; A war "0".."8"

  ; A war nicht numerisch
  cjne a,#70,testupcase1       ; Test auf Gross-Kleinschreibung 70="F"
  sjmp hinibble                ; gelesenes Zeichen war "F"
testupcase1:
  jc hinibble                  ; gelesenes Zeichen war kleiner als ASCII 70
  subb a,#32                   ; Klein = Grossbuchstaben konvertieren
hinibble:                      ; ab hier sind es Grossbuchstaben
  clr c
  push acc
  subb a,#55                   ; a= chr(a)-55 (Alphanumerisch in Zahl umrechn.)
  mov r1,a
  pop acc
  ret
numziffer:
  clr c
  push acc
  subb a,#48                   ; a= chr(a)-48 (Numerisch in Zahl umrechn.)
  mov r1,a
  pop acc
  ret

getrs232hex:
  ; liest einen Hex-Wert (2 stellig) auf der seriellen Schnittstelle ein
  ; Rckgabe:         A = gelesener Wert
  push 06
  push 01
  acall readchar
  acall convhexchar
  mov a,r1
  mov b,#16
  mul ab
  mov r6,a
  acall readchar
  acall convhexchar
  mov a,r6
  add a,r1
  pop 01
  pop 06
  ret
  
getrs232hex_echo:
  ; liest einen Hex-Wert (2 stellig) auf der seriellen Schnittstelle ein 
  ; und schickt die Eingaben auf der RS232 wieder zurck
  ; Rckgabe:         A = gelesener Wert

  push 06
  push 01
  acall readchar
  acall sendchar
  acall convhexchar
  mov a,r1
  mov b,#16
  mul ab
  mov r6,a
  acall readchar
  acall sendchar
  acall convhexchar
  mov a,r6
  add a,r1
  pop 01
  pop 06
  ret

writehex2rs232:
  ; schreibt A als Hex-Wert auf der RS-232
  ; bergabe:         A = zu schreibender Wert
  push acc
  push acc
  clr c
  rrc a
  rrc a
  rrc a
  rrc a                ; oberes Nibble ins untere Nibble verschieben
  anl a,#0fh
  cjne a,#10,writehex2_num
  clr c
writehex2_alpha:       ; schreibe grosses Alphanumerisches Zeichen
  jc writehex2_num
  clr c
  add a,#55            ; Ziffernwert nach alphanumerischen Zeichen konvertieren
  sjmp writehex2_aus
writehex2_num:
  jnc writehex2_alpha
  clr c
  add a,#48            ; Ziffernwert nach numerisches Zeichen konvertieren
writehex2_aus:
  acall sendchar
  pop acc
  anl a,#0fh           ; Akku maskieren, oberes Nibble loeschen

  cjne a,#10,writehex2_numlo
  clr c
writehex2_alphalo:     ; schreibe grosses Alphanumerisches Zeichen
  jc writehex2_numlo
  clr c
  add a,#55            ; Ziffernwert nach alphanumerischen Zeichen konvertieren
  sjmp writehex2_auslo
writehex2_numlo:
  jnc writehex2_alphalo
  clr c
  add a,#48            ; Ziffernwert nach numerisches Zeichen konvertieren
writehex2_auslo:
  acall sendchar

  pop acc
  ret
  
writeword2rs232:
  ; gibt einen 16-Bit Wert hexadezimal auf der RS-232 aus
  ; bergabe:         R0: niederwertige 8 Bit
  ;                   R1: hherwertige 8 Bit
  push 0
  push 1
  mov a,r1
  acall writehex2rs232
  mov a,r0
  acall writehex2rs232
  pop 1
  pop 0
  ret


InitTimer:
  ; initialisiert Timer1 fr ser. Schnittstelle auf 9600 Baud
  ; Timer0 ist ein 8-Bit Autoreloadtimer.

  setb p3.5
  mov tmod,#22h        ; Timer 0 und Timer 1 als 8 Bit Reload Timer
  setb ea              ; grundsaetzlich Interrupts zulassen
  clr et1              ; Timer 1 Overflow Interrupt aus
  setb et0             ; Timer 0 Overflow Interrupt an
  ; mov th1,#0fdh      ; FDh = Reload Wert fr 9600 Baud setzen / 11.0592 MHz
                       ; F3H = Reload Wert fr 2400 Baud setzen / 12 MHz
  setb tr1             ; Timer 1 starten
  mov scon,#50h        ; Serielle Schnittstellenmodus festlegen
  anl pcon,#07fh
  jb p3.5,doublebaud   ; P3.5 = Bautratenselector 28800 / 115200 Baud
  mov th1,#0feh        ; FEh = Reload Wert fuer 28800 Baud / 22.1184MHz
  ;mov th1,#0fdh        ; FDh = Reload Wert fuer 19200 Baud / 22.1184MHz
  anl pcon,#7fh
  ret
doublebaud:
  mov th1,#0ffh        ; FFh = Reloadwert fuer 57600 Baud setzen / 22.1184 MHz
  orl pcon,#80h        ; PCON.7 = SMOD1 setzen (doppelte Baudrate) = 115200 Baud
  ret


end

